class LessTele expands mutator config(LessTele);

var bool bPostInit;
var config bool bVerbose;
var config int SpawnRadius;
var DeathMatchPlus MyGame;
var const string version;
var int NumAds, NumCrtS, Num0, Num1;

event PostBeginPlay()
{
	if (!bPostInit)
	{
		bPostInit = True;
		if ( DeathMatchPlus(Level.Game) != None )
			MyGame = DeathMatchPlus(Level.Game);
		log (Self@" has been loaded and started.");
		if ( SpawnRadius < 100 )
			SpawnRadius = 100;
		if ( SpawnRadius > 710 )
			SpawnRadius = 710;
		DoAddsToNeeds();
		SaveConfig();
	}
	else
	{
		log (Self@" being already started has been called again, please check your configuration...");
	}
}

function ModifyPlayer (Pawn Other)
{
	local Pawn aPawn, OtherPawn;
	local NavigationPoint N;
	local bool bSpotBusy, bStillBusy, bJobDone;

	if ( Other.PlayerReplicationInfo == None ) return; //Don't let something to mess up - block chain by default

	if ( MyGame != None )
	{
		foreach RadiusActors (class 'Pawn',aPawn,25,Other.Location)
		{
			if ( aPawn != Other )
			{
				if ( bVerbose && MyGame.bStartMatch )
					log ( Other.GetHumanName()@"might be colliding with"@aPawn.GetHumanName() );
				bSpotBusy = True;
				break;
			}
		}
		if ( bSpotBusy )
		{
			foreach RadiusActors( class'NavigationPoint',N,SpawnRadius,Other.Location )
			{
				if ( Teleporter(N) == None )
				{
					if ( bVerbose && MyGame.bStartMatch )
						log ( "Testing"@N.Name@"if available...");
					bStillBusy = False;
					foreach RadiusActors (class 'Pawn',OtherPawn,25,N.Location)
					{
						if ( OtherPawn != Other )
						{
							if ( bVerbose && MyGame.bStartMatch )
								log ( N.Name@"is not available."@OtherPawn.GetHumanName()@"has been found there.");
							bStillBusy = True;
							break;
						}
					}
				}
				if (!bStillBusy)
				{
					bJobDone = Other.SetLocation(N.Location);
					break;
				}
			}
			if (bJobDone)
			{
				if ( bVerbose && MyGame.bStartMatch )
					log ( Other.GetHumanName()@"will use"@N.Name@"for start...");
			}
		}
	}
	Super.ModifyPlayer(Other);
}

function DoAddsToNeeds()
{
	local PlayerStart Ps;
	local EPlayerStart Psa;
	local NavigationPoint N;
	local bool bTooClose;

	foreach AllActors (class 'Engine.PlayerStart', Ps) //Acquire PlayerStarts
	{
		if ( Ps.Class == class 'Engine.PlayerStart' )
		{
			if ( Ps.TeamNumber == 0 )
			{
				if ( Num0 < 16 )
					Num0++;
				if ( Num0 > 15 ) continue;
			}
			else
			{
				if ( Num1 < 16 )
					Num1++;
				if ( Num1 > 15 ) continue;
			}
		}

		foreach RadiusActors ( class 'NavigationPoint',N,40,Ps.Location ) //check for nearby craps
		{
			if ( N != Ps )
			{
				bTooClose=True;
				break;
			}
		}
		if ( bTooClose )
		{
			bTooClose=False; //Reset and see the next
			continue;
		}
		if ( Ps.Class == class 'Engine.PlayerStart' ) //An Original ?
		{
			if ( Ps.TeamNumber == 0 )
			{
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(56,0,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(56,0,20) ) //If went wrong
						Psa.bUseless = True; //Let it ruin itself
					else
					{
						Psa.TeamNumber=Ps.TeamNumber; //Set TeamNumber
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num0++; //Count it
						NumAds++; //Count added Starts
					}
				}
				Psa = None;
				if ( Num0 > 15 ) //at Capacity ?
					continue; //Move to next - Purpose is checking both Teams
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(-56,0,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(-56,0,20) )
						Psa.bUseless = True; //Let it ruin itself
					else
					{
						Psa.TeamNumber=Ps.TeamNumber;
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num0++;
						NumAds++;
					}
				}
				Psa = None;
				if ( Num0 > 15 ) //at Capacity
					continue;
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(0,56,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(0,56,20) )
						Psa.bUseless = True;
					else
					{
						Psa.TeamNumber=Ps.TeamNumber;
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num0++;
						NumAds++;
					}
				}
				Psa = None;
				if ( Num0 > 15 ) //at Capacity
					continue;
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(0,-56,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(0,-56,20) )
						Psa.bUseless = True;
					else
					{
						Psa.TeamNumber=Ps.TeamNumber;
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num0++;
						NumAds++;
					}
				}
				Psa = None;
				if ( Num0 > 15 ) //at Capacity
					continue;
			}
			else //It might be only 2 Teams - Probably next version will include some arrays for multi-farts
			{
				Psa = None;
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(56,0,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(56,0,20) )
						Psa.bUseless = True; //Let it ruin itself
					else
					{
						Psa.TeamNumber=Ps.TeamNumber; //Set TeamNumber
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num1++; //Count it
						NumAds++; //Count added Starts
					}
				}
				Psa = None;
				if ( Num1 > 15 ) //at Capacity ?
					continue;
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(-56,0,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(-56,0,20) )
						Psa.bUseless = True; //Let it ruin itself
					else
					{
						Psa.TeamNumber=Ps.TeamNumber;
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num1++;
						NumAds++;
					}
				}
				Psa = None;
				if ( Num1 > 15 ) //at Capacity
					continue;
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(0,56,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(0,56,20) )
						Psa.bUseless = True;
					else
					{
						Psa.TeamNumber=Ps.TeamNumber;
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num1++;
						NumAds++;
					}
				}
				Psa = None;
				if ( Num1 > 15 ) //at Capacity
					continue;
				Psa = Spawn(class'EPlayerStart',,,Ps.Location+vect(0,-56,20));
				if ( Psa != None && !Psa.bDeleteMe )
				{
					if ( Psa.Location != Ps.Location+vect(0,-56,20) )
						Psa.bUseless = True;
					else
					{
						Psa.TeamNumber=Ps.TeamNumber;
						Psa.bEnabled=Ps.bEnabled;
						Psa.Tag=Ps.Tag;
						Num1++;
						NumAds++;
					}
				}
				Psa = None;
				if ( Num1 > 15 ) //at Capacity
					continue;
			}
		}
	}

	if ( bVerbose )
	{
		log ( Self.Name@"has added"@NumAds@"additional PlayerStart types...");
		log ( Num0@Num1 );
	}
}

defaultproperties
{
	bVerbose=True
	SpawnRadius=500
	version="2.00"
}